require 'ffi'
require 'rb-alsacap/pcm_format'

# A module that wraps the required functions from libasound.
module LibAsound
  extend FFI::Library

  ffi_lib 'asound'

  SND_PCM_NONBLOCK = 0x00000001

  enum :snd_pcm_stream_t, [:SND_PCM_STREAM_PLAYBACK, 0,
                           :SND_PCM_STREAM_CAPTURE,  1,
                           :SND_PCM_STREAM_LAST,     1]
  enum :snd_pcm_format_t, get_format()

  attach_function :snd_card_next, [ :pointer ] , :int

  attach_function :snd_ctl_open , [ :pointer, :string, :int], :int
  attach_function :snd_ctl_close, [ :pointer ]              , :int

  attach_function :snd_ctl_card_info_sizeof, [ ], :size_t
  attach_function :snd_ctl_card_info_get_id  , [ :pointer ]          , :string
  attach_function :snd_ctl_card_info_get_name, [ :pointer ]          , :string
  attach_function :snd_ctl_card_info         , [ :pointer, :pointer ], :int

  attach_function :snd_ctl_pcm_next_device, [ :pointer, :pointer ], :int
  attach_function :snd_ctl_pcm_info       , [ :pointer, :pointer ], :int

  attach_function :snd_pcm_info_sizeof, [ ], :size_t
  attach_function :snd_pcm_info_get_subdevices_count, [ :pointer ], :uint
  attach_function :snd_pcm_info_get_subdevices_avail, [ :pointer ], :uint
  attach_function :snd_pcm_info_get_id            , [ :pointer ], :string
  attach_function :snd_pcm_info_get_name          , [ :pointer ], :string
  attach_function :snd_pcm_info_get_subdevice_name, [ :pointer ], :string
  attach_function :snd_pcm_info_set_device   , [ :pointer, :uint ], :void
  attach_function :snd_pcm_info_set_subdevice, [ :pointer, :uint ], :void
  attach_function :snd_pcm_info_set_stream, [ :pointer, :snd_pcm_stream_t ], :void

  attach_function :snd_pcm_open , [ :pointer, :string, :snd_pcm_stream_t, :int ], :int
  attach_function :snd_pcm_close, [ :pointer ], :int

  attach_function :snd_pcm_format_mask_sizeof, [ ], :size_t
  attach_function :snd_pcm_format_mask_test  , [ :pointer, :snd_pcm_format_t ], :int
  attach_function :snd_pcm_format_name       , [ :snd_pcm_format_t ]          , :string

  attach_function :snd_pcm_hw_params_sizeof          , [ ], :size_t
  attach_function :snd_pcm_hw_params_get_sbits       , [ :pointer ], :int
  attach_function :snd_pcm_hw_params_any             , [ :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_get_channels_min, [ :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_get_channels_max, [ :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_get_format_mask , [ :pointer, :pointer ], :void
  attach_function :snd_pcm_hw_params_get_rate_min , [ :pointer, :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_get_rate_max , [ :pointer, :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_set_rate_near, [ :pointer, :pointer, :pointer, :pointer ], :int
  attach_function :snd_pcm_hw_params_set_channels , [ :pointer, :pointer, :uint], :int
  attach_function :snd_pcm_hw_params_set_format   , [ :pointer, :pointer, :snd_pcm_format_t], :int

end
